function [sm,Asymp_Sigma_matrix]=delta_smoothed(yt,thn,asymp_var_prm)
global ns; global pphi;
ll=length(thn);
n=ns^(pphi+1);
nk=pphi+1;
capt=length(yt);
captst=capt-pphi;
skif=zeros(captst,n);

mun=thn(1:ns);
phin=[1;-thn(ns+1:ns+pphi)];
hp=hpfun(pphi);
const=kron(phin,mun);
const=const'*hp;
eta1=yt(nk:capt);
for iz=1:pphi
    eta1=[eta1 yt(nk-iz:capt-iz)];
end
eta2=repmat(eta1*phin,1,n)-repmat(const,captst,1);

sig=repmat(thn(ns+pphi+1:ns+pphi+ns),1,n).*hp(1:ns,:);
sig2=sum(sig);
eta0=((eta2).^2)./repmat(sig2,captst,1);
eta=repmat((1./sqrt(2*pi.*sig2)),captst,1).*exp(-eta0/2); % likelihood function given st*
 
nco=ns+pphi+ns;
pm=zeros(ns,ns); % Transition probabilities matrix st
for it=1:ns
    pm(1:ns-1,it)=thn(nco+(ns-1)*(it-1)+1:nco+(ns-1)*it);    
end
pm(ns,:)=1-sum(pm);
fm=matf(pm,pphi);       % Transition probabilities matrix st*
% chsi=ones(n,1)/n;     % Initial filtered probs from Uniform
ap=[eye(n)-fm;ones(1,n)];        % Ergodic Initial filtered probs
chsi2=sum((inv(ap'*ap)))';
chsi2=max([chsi2';zeros(1,n)])';  % This line eliminates roundoff error @
chsi=chsi2;
            
fhi=zeros(captst,1);
for it=1:captst  
    fx=chsi.*eta(it,:)';  % nx1 conditional likelihood
    ftotal=sum(fx);       % 1x1 Likelihood of the mixture 
    fhi(it)=ftotal;
    skif(it,:)=fx'/ftotal;
    chsi=fm*fx/ftotal;    % nx1 forecasted probs
end
delta_nu=zeros(captst,n*ns);
delta_phi=zeros(captst,n*pphi);
delta_sigma=zeros(captst,n*ns);
mu=thn(1:ns)';              % 1xns vector of means
ar=thn(ns+1:ns+pphi)';      % 1xpphi vector of autoreg params
phin2=[-1 ar];              
Id=eye(pphi+1);             
for it=1:captst
    for j=1:ns;
        const2=kron(phin2,Id(j,:));
        const2=const2*hp;
        delta_nu(it,(j-1)*n+1:j*n)=-eta(it,:).*eta2(it,:).*const2./sig2;
    end;
    for j=1:pphi;
        const2=kron(Id(j+1,:),mu);const2=const2*hp;
        const3=kron(Id(j+1,:),repmat(eta1(it,j+1),1,ns));const3=const3*hp;
        const4=const2-const3;
        delta_phi(it,(j-1)*n+1:j*n)=-eta(it,:).*eta2(it,:).*const4./sig2;      
    end;
    for j=1:ns;
        delta_sigma(it,(j-1)*n+1:j*n)=hp(j,:).*(0.5*eta(it,:)./sig2).*((eta2(it,:).^2)./sig2-1);
    end;
end

Gt_star=[chsi2';skif];                % P(St*=i|yt) captst+1 x n        
nco=ns+pphi+ns;
kk=diag(ones(ns,1))-0.5;kk=kk(1:ns-1,:);
kk=[zeros(1,nco) kk(1:end)];  
kk=kron(kk,ones(1,n));
delta_Gt_star=zeros(captst,ll*n);  
delta_Gt_star=[kk;delta_Gt_star];      % dP(St*=i|yt) captst+1 x n
fhi=[0;fhi];
fhi_i=[zeros(1,n);eta];
delta_nu=[zeros(1,n*ns);delta_nu];
delta_phi=[zeros(1,n*pphi);delta_phi];
delta_sigma=[zeros(1,n*ns);delta_sigma];
delta_p=zeros(captst+1,(ns-1)*ns*n);

dphp=zeros(n,n); % Matrix of derivative of fm'
for j=1:ns; % partial derivatives with respect to mu
    for it=2:captst+1;
        delta_Gt_star(it,(j-1)*n+1:j*n)=(1./repmat(fhi(it),1,n).^2).*((delta_nu(it,(j-1)*n+1:j*n).*(Gt_star(it-1,:)*fm')+...
                                        fhi_i(it,:).*(delta_Gt_star(it-1,(j-1)*n+1:j*n)*fm'+Gt_star(it-1,:)*dphp)).*repmat(fhi(it),1,n)-...
                                        fhi_i(it,:).*(Gt_star(it-1,:)*fm')*sum(delta_nu(it,(j-1)*n+1:j*n).*(Gt_star(it-1,:)*fm')+...
                                                      fhi_i(it,:).*(Gt_star(it-1,:)*dphp+delta_Gt_star(it-1,(j-1)*n+1:j*n)*fm')));                                                  
    end;
end;

nco=ns*n;
dphp=zeros(n,n);
for j=1:pphi; % partial derivatives with respect to phi
    for it=2:captst+1;
        delta_Gt_star(it,nco+(j-1)*n+1:nco+j*n)=(1./repmat(fhi(it),1,n).^2).*((delta_phi(it,(j-1)*n+1:j*n).*(Gt_star(it-1,:)*fm')+...
                                        fhi_i(it,:).*(delta_Gt_star(it-1,(j-1)*n+1:j*n)*fm'+Gt_star(it-1,:)*dphp)).*repmat(fhi(it),1,n)-...
                                        fhi_i(it,:).*(Gt_star(it-1,:)*fm')*sum(delta_phi(it,(j-1)*n+1:j*n).*(Gt_star(it-1,:)*fm')+...
                                                      fhi_i(it,:).*(Gt_star(it-1,:)*dphp+delta_Gt_star(it-1,(j-1)*n+1:j*n)*fm')));                                                  
    end;
end;
   
nco=(ns+pphi)*n;
dphp=zeros(n,n);
for j=1:ns; % partial derivatives with respect to sigma
    for it=2:captst+1;
        delta_Gt_star(it,nco+(j-1)*n+1:nco+j*n)=(1./repmat(fhi(it),1,n).^2).*((delta_sigma(it,(j-1)*n+1:j*n).*(Gt_star(it-1,:)*fm')+...
                                        fhi_i(it,:).*(delta_Gt_star(it-1,(j-1)*n+1:j*n)*fm'+Gt_star(it-1,:)*dphp)).*repmat(fhi(it),1,n)-...
                                        fhi_i(it,:).*(Gt_star(it-1,:)*fm')*sum(delta_sigma(it,(j-1)*n+1:j*n).*(Gt_star(it-1,:)*fm')+...
                                                      fhi_i(it,:).*(Gt_star(it-1,:)*dphp+delta_Gt_star(it-1,(j-1)*n+1:j*n)*fm')));                                                  
    end;
end;

nco=(ns+pphi+ns)*n;
for j=1:(ns-1)*ns; % partial derivatives with respect to pij  
   man=zeros(ns*(ns-1),1);
   man(j)=1;
   pmk=zeros(ns,ns); % Transition probabilities matrix st
   for it=1:ns;
       pmk(1:ns-1,it)=man((ns-1)*(it-1)+1:(ns-1)*it);    
   end;
   pmk(end,:)=-ones(1,ns).*sum(pmk); 
   dphp=matf(pmk,pphi);       % Transition probabilities matrix st*
   dphp=dphp';
   for it=2:captst+1;
        delta_Gt_star(it,nco+(j-1)*n+1:nco+j*n)=(1./repmat(fhi(it),1,n).^2).*((delta_p(it,(j-1)*n+1:j*n).*(Gt_star(it-1,:)*fm')+...
                                        fhi_i(it,:).*(delta_Gt_star(it-1,(j-1)*n+1:j*n)*fm'+Gt_star(it-1,:)*dphp)).*repmat(fhi(it),1,n)-...
                                        fhi_i(it,:).*(Gt_star(it-1,:)*fm')*sum(delta_p(it,(j-1)*n+1:j*n).*(Gt_star(it-1,:)*fm')+...
                                                      fhi_i(it,:).*(Gt_star(it-1,:)*dphp+delta_Gt_star(it-1,(j-1)*n+1:j*n)*fm')));                                                  
    end;
end;

Gt_star=Gt_star(2:end,:);
delta_Gt_star=delta_Gt_star(2:end,:);
hpp=hp';
Gt=Gt_star*hpp(:,1:ns);                           % P(St=i|yt) captst x ns vector of filtered probs  
delta_Gt2=[];                                     % rearranged dP(S*t=i|yt) captst x ll*n vector of derivatives  
for j=1:ll;
    delta_Gt2=[delta_Gt2 delta_Gt_star(:,(j-1)*n+1:j*n)*hpp(:,1:ns)];
end;

sm=smoother(Gt,thn);
delta_sm2=zeros(captst,ll*ns);
delta_sm2(captst,:)=delta_Gt2(captst,:);

nco=0;
dphp=zeros(ns,ns);
for j=1:ns; % partial derivatives with respect mu
    for it=captst-1:-1:1 
        fp=Gt(it,:)*pm';
        fp2=fp.^2;
        delta_fp=delta_Gt2(it,nco+(j-1)*ns+1:nco+j*ns)*pm'+Gt(it,:)*dphp';
        delta_sm2(it,nco+(j-1)*ns+1:nco+j*ns)=delta_Gt2(it,nco+(j-1)*ns+1:nco+j*ns).*((sm(it+1,:)./fp)*pm)+...
            Gt(it,:).*((delta_sm2(it+1,nco+(j-1)*ns+1:nco+j*ns)./fp)*pm)+Gt(it,:).*((sm(it+1,:)./fp)*dphp)-Gt(it,:).*((sm(it+1,:).*delta_fp./fp2)*pm);  
  end;
end;

nco=ns*ns;
dphp=zeros(ns,ns);
for j=1:pphi; % partial derivatives with respect phi
    for it=captst-1:-1:1 
        fp=Gt(it,:)*pm';
        fp2=fp.^2;
        delta_fp=delta_Gt2(it,nco+(j-1)*ns+1:nco+j*ns)*pm'+Gt(it,:)*dphp';
        delta_sm2(it,nco+(j-1)*ns+1:nco+j*ns)=delta_Gt2(it,nco+(j-1)*ns+1:nco+j*ns).*((sm(it+1,:)./fp)*pm)+...
            Gt(it,:).*((delta_sm2(it+1,nco+(j-1)*ns+1:nco+j*ns)./fp)*pm)+Gt(it,:).*((sm(it+1,:)./fp)*dphp)-Gt(it,:).*((sm(it+1,:).*delta_fp./fp2)*pm);  
    end;
end;

nco=(ns+pphi)*ns;
dphp=zeros(ns,ns);
for j=1:ns; % partial derivatives with respect to sigma
    for it=captst-1:-1:1 
        fp=Gt(it,:)*pm';
        fp2=fp.^2;
        delta_fp=delta_Gt2(it,nco+(j-1)*ns+1:nco+j*ns)*pm'+Gt(it,:)*dphp';
         delta_sm2(it,nco+(j-1)*ns+1:nco+j*ns)=delta_Gt2(it,nco+(j-1)*ns+1:nco+j*ns).*((sm(it+1,:)./fp)*pm)+...
            Gt(it,:).*((delta_sm2(it+1,nco+(j-1)*ns+1:nco+j*ns)./fp)*pm)+Gt(it,:).*((sm(it+1,:)./fp)*dphp)-Gt(it,:).*((sm(it+1,:).*delta_fp./fp2)*pm);  
 end;
end;

nco=(ns+pphi+ns)*ns;
for j=1:(ns-1)*ns; % partial derivatives with respect to pij
    man=zeros(ns*(ns-1),1);
    man(j)=1;
    pmk=zeros(ns,ns); % Transition probabilities matrix st
    for ite=1:ns;
        pmk(1:ns-1,ite)=man((ns-1)*(ite-1)+1:(ns-1)*ite);    
    end;
    pmk(end,:)=-ones(1,ns).*sum(pmk); 
    dphp=pmk;
    for it=captst-1:-1:1
        fp=Gt(it,:)*pm';
        fp2=fp.^2;
        delta_fp=delta_Gt2(it,nco+(j-1)*ns+1:nco+j*ns)*pm'+Gt(it,:)*dphp';
        delta_sm2(it,nco+(j-1)*ns+1:nco+j*ns)=delta_Gt2(it,nco+(j-1)*ns+1:nco+j*ns).*((sm(it+1,:)./fp)*pm)+...
            Gt(it,:).*((delta_sm2(it+1,nco+(j-1)*ns+1:nco+j*ns)./fp)*pm)+Gt(it,:).*((sm(it+1,:)./fp)*dphp)-Gt(it,:).*((sm(it+1,:).*delta_fp./fp2)*pm);  
    end;
end;

kk=eye(ns);
Asymp_Sigma_matrix=zeros(captst,ns);
for j=1:ns;
    ind=kron(ones(1,ll),kk(j,:));
    delta_sm=delta_sm2(:,logical(ind));  % dP(St=i|yt) captst x ll vector of derivatives 
    for it=1:captst
        Asymp_Sigma_matrix(it,j)=delta_sm(it,:)*(asymp_var_prm)*delta_sm(it,:)';
    end
end;

function results1=hpfun(pphi)  % To compute filtered of primitive states
global ns;
n=ns^(pphi+1);
nm=n/ns;
ix=kron(eye(ns),ones(1,nm));
for i1=1:pphi;
    nm=nm/ns;
    iq=kron(ones(1,ns^i1),kron(eye(ns),ones(1,nm)));
    ix=[iq;ix];
end;    
results1=ix;    
     

function results2=matf(pm2,pphi)  % Transition probs matrix
global ns
nm=1;
nb=ns;
nc=ns*ns;
fm2=pm2;
for iz=1:pphi;
    fz=fm2;
    fm2=zeros(nc,nc);
    for iw=1:ns;
        fm2(((iw-1)*nb+1):(iw*nb),((iw-1)*nm+1):(iw*nm))=fz(1:nb,((iw-1)*nm+1):iw*nm);    
    end;
    for ib=2:ns;
        fm2(1:nc,((ib-1)*nb+1):ib*nb)=fm2(1:nc,1:nb);        
    end;
    nm=nm*ns;
    nb=nb*ns;
    nc=nc*ns;
end;
results2=fm2;

function resu=smoother(skifn,th2)
global ns;global pphi;
captst=size(skifn,1);
n=size(skifn,2);
skisn=zeros(captst,n);
skisn(captst,:)=skifn(captst,:);
nco=ns+pphi+ns;
pm=zeros(ns,ns); % Transition probabilities matrix st
for it=1:ns
    pm(1:ns-1,it)=th2(nco+(ns-1)*(it-1)+1:nco+(ns-1)*it);    
end
pm(ns,:)=1-sum(pm);
% fm=matf(pm,pphi);     % Transition probabilities matrix
for it=1:captst-1
    if min(skifn(captst-it,:)') > 1.e-150;
       skisn(captst-it,:)=skifn(captst-it,:).*((skisn(captst-it+1,:)./(skifn(captst-it,:)*pm'))*pm);
    else
       hk=skifn(captst-it,:)*pm';
       for ihk=1:n
          if hk(1,ihk) > 1.e-150;
             hk(1,ihk) = skisn(captst-it+1,ihk)/hk(1,ihk);
          else
             hk(1,ihk) = 0;
          end

       end
       skisn(captst-it,:) = skifn(captst-it,:).*(hk*pm);
    end
end;
resu=skisn;